Package org.eclipse.emf.cdo.common.revision

# Enum Class CDORevisionCrawler.ContainmentProxyStrategy

java.lang.Object
java.lang.Enum<CDORevisionCrawler.ContainmentProxyStrategy>
org.eclipse.emf.cdo.common.revision.CDORevisionCrawler.ContainmentProxyStrategy

All Implemented Interfaces:
  `Serializable`, `Comparable<CDORevisionCrawler.ContainmentProxyStrategy>`, `Constable`

Enclosing class:
  `CDORevisionCrawler`

public static enum CDORevisionCrawler.ContainmentProxyStrategy extends Enum<CDORevisionCrawler.ContainmentProxyStrategy>
Strategy for handling containment proxies during crawling.

Author:
  Eike Stepper

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`Any`
Follows all containment proxies.
`Logical`
Follows only logical containment proxies (parent is not resource).
`Physical`
Follows only physical containment proxies (parent is resource).

## Method Summary

Modifier and Type
Method
Description
`protected abstract boolean`
`follow(boolean parentIsResource)`
Determines whether to follow a containment proxy based on parent resource status.
`static CDORevisionCrawler.ContainmentProxyStrategy`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static CDORevisionCrawler.ContainmentProxyStrategy[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### Physical

public static final CDORevisionCrawler.ContainmentProxyStrategy Physical
Follows only physical containment proxies (parent is resource).

### Logical

public static final CDORevisionCrawler.ContainmentProxyStrategy Logical
Follows only logical containment proxies (parent is not resource).

### Any

public static final CDORevisionCrawler.ContainmentProxyStrategy Any
Follows all containment proxies.

## Method Details

### values

public static CDORevisionCrawler.ContainmentProxyStrategy[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static CDORevisionCrawler.ContainmentProxyStrategy valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### follow

protected abstract boolean follow(boolean parentIsResource)
Determines whether to follow a containment proxy based on parent resource status.

Parameters:
  `parentIsResource` - true if parent is a resource
Returns:
  true to follow, false otherwise